# -*- coding: utf-8 -*-

import smtpd
import ssl
import asyncore
import asynchat
import errno

asynchat._BLOCKING_IO_ERRORS = (list(asynchat._BLOCKING_IO_ERRORS) +
                                [errno.ENOENT])


class SMTPChannel(smtpd.SMTPChannel):
    def readable(self):
        if isinstance(self.socket, ssl.SSLSocket):
            self.handle_read()
        return 1


class SSLDebuggingServer(smtpd.DebuggingServer):
    def create_socket(self, proto, type):
        smtpd.DebuggingServer.create_socket(self, proto, type)
        sslsocket = ssl.wrap_socket(self.socket,
                                    server_side=True,
                                    certfile='server.pem',
                                    keyfile='server.pem')
        self.set_socket(sslsocket)

    def handle_accept(self):
        pair = self.accept()
        if pair is not None:
            conn, addr = pair
            print 'Incoming connection from %s' % repr(addr)
            channel = SMTPChannel(self, conn, addr)

if __name__ == '__main__':
    SSLDebuggingServer(('localhost', 1025), 'localhost:25')
    asyncore.loop()
    